net.sf.saxon.expr

## Class FilterIterator

- java.lang.Object
- - net.sf.saxon.expr.FilterIterator

- All Implemented Interfaces:
    SequenceIterator
  Direct Known Subclasses:
    FilterIterator.NonNumeric

      public class FilterIterator
      extends Object
      implements SequenceIterator

  A CompiledFilterIterator filters an input sequence using a filter expression. Note that a CompiledFilterIterator is not used where the filter is a constant number (PositionFilter is used for this purpose instead), so this class does no optimizations for numeric predicates.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `FilterIterator.NonNumeric` Subclass to handle the common special case where it is statically known that the filter cannot return a numeric value

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected SequenceIterator` | `base`
    `protected Expression` | `filter`
    `protected XPathContext` | `filterContext`

    - ### Fields inherited from interface net.sf.saxon.om.SequenceIterator

      `GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FilterIterator(SequenceIterator base, Expression filter, XPathContext context)` Constructor

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close the iterator.
    `Item` | `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
    `SequenceIterator` | `getAnother()` Get another iterator to return the same nodes
    `protected Item` | `getNextMatchingItem()` Get the next item in the base sequence that matches the filter predicate if there is such an item, or null if not.
    `int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
    `protected boolean` | `matches()` Determine whether the context item matches the filter predicate
    `Item` | `next()` Get the next item if there is one
    `int` | `position()` Get the current position.
    `void` | `setSequence(SequenceIterator base, XPathContext context)` Set the base iterator

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### base

          protected SequenceIterator base

    - #### filter

          protected Expression filter

    - #### filterContext

          protected XPathContext filterContext

  - ### Constructor Detail

    - #### FilterIterator

          public FilterIterator(SequenceIterator base,
                        Expression filter,
                        XPathContext context)

      Constructor
      Parameters:
        `base` - An iteration of the items to be filtered
        `filter` - The expression defining the filter predicate
        `context` - The context in which the expression is being evaluated

  - ### Method Detail

    - #### setSequence

          public void setSequence(SequenceIterator base,
                         XPathContext context)

      Set the base iterator
      Parameters:
        `base` - the iterator over the sequence to be filtered
        `context` - the context in which the (outer) filter expression is evaluated

    - #### next

          public Item next()
                    throws XPathException

      Get the next item if there is one
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### getNextMatchingItem

          protected Item getNextMatchingItem()
                                      throws XPathException

      Get the next item in the base sequence that matches the filter predicate if there is such an item, or null if not.
      Returns:
        the next item that matches the predicate
      Throws:
        `XPathException`

    - #### matches

          protected boolean matches()
                             throws XPathException

      Determine whether the context item matches the filter predicate
      Returns:
        true if the context item matches
      Throws:
        `XPathException`

    - #### current

          public Item current()

      Description copied from interface: `SequenceIterator`
      Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next(). This method does not change the state of the iterator.
      Specified by:
        `current` in interface `SequenceIterator`
      Returns:
        the current item, the one most recently returned by a call on next(). Returns null if next() has not been called, or if the end of the sequence has been reached.

    - #### position

          public int position()

      Description copied from interface: `SequenceIterator`
      Get the current position. This will usually be zero before the first call on next(), otherwise it will be the number of times that next() has been called. Once next() has returned null, the preferred action is for subsequent calls on position() to return -1, but not all existing implementations follow this practice. (In particular, the EmptyIterator is stateless, and always returns 0 as the value of position(), whether or not next() has been called.)

      This method does not change the state of the iterator.

      Specified by:
        `position` in interface `SequenceIterator`
      Returns:
        the current position, the position of the item returned by the most recent call of next(). This is 1 after next() has been successfully called once, 2 after it has been called twice, and so on. If next() has never been called, the method returns zero. If the end of the sequence has been reached, the value returned will always be <= 0; the preferred value is -1.

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

      Specified by:
        `close` in interface `SequenceIterator`

    - #### getAnother

          public SequenceIterator getAnother()
                                      throws XPathException

      Get another iterator to return the same nodes
      Specified by:
        `getAnother` in interface `SequenceIterator`
      Returns:
        a SequenceIterator that iterates over the same items, positioned before the first item
      Throws:
        `XPathException` - if any error occurs

    - #### getProperties

          public int getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.